% Usage z = cheb_zeros_2D_grid (n)
%
% cheb (z(i,1),n(1)) == 0
% cheb (z(i,2),n(2)) == 0
% cheb_zeros(n(1)) \tensor cheb_zeros(n(2)) in some linear order
%
% $Id$
%

function z = cheb_zeros_2D_grid (n)
  n1 = n(1);
  n2 = n(2);
  z = [(kron (cheb_zeros (n1), ones (n2, 1))), \
       (kron (ones (n1, 1), cheb_zeros (n2)))];
endfunction


% Local Variables: %
% mode: octave     %
% End:             %
