# Usage gs = msn_reinterp (s, m, a, b, xs, fs, ys)
#
# s --- Sobolev weight
# m --- m * size(xs,1) is the order of the Chebyshev polynomial
# a --- left end-point of interval
# b --- right end-point interval
# xs --- Sample points
# fs --- Function at sample points
# ys --- Points at which to evaluate MSN interpolant
# gs --- MSN interpolant evaluated at ys
#
# $Id$
#

function gs = msn_reinterp (s, m, a, b, xs, fs, ys)
  gs = samp_cheb (msn_interp (s, m, a, b, xs, fs), a, b, ys);
endfunction

# Local Variables: #
# mode: octave     #
# End:             #
