# Usage fs = samp_cheb (a, xs)
#
# as --- Cheb. coefficients
# a --- left end-point
# b --- right end-point
# xs --- points where the Cheb. expansion should be evaluated
#
# $Id$
#

function fs = samp_cheb (as, a, b, xs)
  zs = from_interval (a, b, xs);
  M = length (as);
  fs = cheb (zs, [0:1:M-1]) * as;
endfunction

# Local Variables: #
# mode: octave     #
# End:             #
