## Test 1_9 of msnPDE.m
##
## Div-curl outside car. See car.svg
##
##
## $Id$
##

#
x1 = 0;
x2 = 7;
x3 = 8;
x4 = 9;
x5 = 10;
x6 = 11;
x7 = 12;
x8 = 13;
x9 = 14;
x10 = 16;
x11 = 19;
x12 = 20;
x13 = 21;
x14 = 22;
x15 = 23;
x16 = 24;
x17 = 25;
x18 = 27;
x19 = 29;
x20 = 36;
#
y1 = 0;
y2 = 1;
y3 = 2;
y4 = 3;
y5 = 4;
y6 = 5;
y7 = 6;
y8 = 7;
y9 = 8;
y10 = 10;
y11 = 14;
#
global Pts;
Pts = [x1 y1;			# 1 <---Line 1---begins
       x2 y1;			# 2
       x3 y1;			# 3
       x4 y1;			# 4
       x6 y1;			# 5
       x7 y1;			# 6
       x9 y1;			# 7
       x11 y1;			# 8
       x13 y1;			# 9
       x14 y1;			# 10
       x16 y1;			# 11
       x18 y1;			# 12
       x19 y1;			# 13
       x20 y1;			# 14 <----Line 1---ends
       x1 y2;			# 15 <---Line 2---begins
       x2 y2;			# 16
       x3 y2;			# 17
       x4 y2;			# 18
       x5 y2;			# 19
       x8 y2;			# 20
       x9 y2;			# 21
       x11 y2;			# 22
       x12 y2;			# 23
       x15 y2;			# 24
       x16 y2;			# 25
       x18 y2;			# 26
       x19 y2;			# 27
       x20 y2;			# 28 <----Line 2---ends
       x1 y3;			# 29 <---Line 3---begins
       x2 y3;			# 30
       x3 y3;			# 31
       x4 y3;			# 32
       x5 y3;			# 33
       x8 y3;			# 34
       x9 y3;			# 35
       x11 y3;			# 36
       x12 y3;			# 37
       x15 y3;			# 38
       x16 y3;			# 39 <----Line 3---ends
       x6 y4;			# 40 <----Line 4---begins
       x7 y4;			# 41
       x13 y4;			# 42
       x14 y4;			# 43 <----Line 4---ends
       x1 y5;			# 44 <----Line 5---begins
       x2 y5;			# 45
       x4 y5;			# 46
       x6 y5;			# 47
       x7 y5;			# 48
       x13 y5;			# 49
       x14 y5			# 50 <----Line 5---ends
       x7 y6;			# 51 <----Line 6---begins
       x17 y6;			# 52
       x18 y6;			# 53
       x19 y6;			# 54
       x20 y6;			# 55 <----Line 6---ends
       x1 y7;			# 56 <----Line 7---begins
       x2 y7;			# 57
       x4 y7;			# 58 <----Line 7---ends
       x7 y8;			# 59 <----Line 8---begins
       x17 y8;			# 60
       x18 y8;			# 61
       x19 y8;			# 62
       x20 y8;			# 63 <----Line 8---ends
       x10 y9;			# 64 <----Line 9---begins
       x14 y9;			# 65 <----Line 9---ends
       x10 y10;			# 66 <----Line 10---begins
       x14 y10;			# 67 <----Line 10---ends
       x1 y11;			# 68 <----Line 11---begins
       x2 y11;			# 69
       x4 y11;			# 70
       x7 y11;			# 71
       x10 y11;			# 72
       x14 y11;			# 73
       x17 y11;			# 74
       x18 y11;			# 75
       x19 y11;			# 76
       x20 y11];		# 77 <----Line 11---ends
#
Lines = {[1 2 3 4 5 6 7 8 9 10 11 12 13 14]; # 1 <---Horizontal lines---begin
	 [15 16 17 18 19 20 21 22 23 24 25 26 27 28]; # 2
	 [29 30 31 32 33 34 35 36 37 38 39];	      # 3
	 [40 41 42 43];				      # 4
	 [44 45 46 47 48 49 50];		      # 5
	 [51 52 53 54 55];			      # 6
	 [56 57 58];				      # 7
	 [59 60 61 62 63];			      # 8
	 [64 65];				      # 9
	 [66 67];				      # 10
	 [68 69 70 71 72 73 74 75 76 77]; # 11 <---Horizontal lines---end
	 [1 15 29 44 56 68];	# 12 <---Vertical lines---begin
	 [2 16 30 45 57 69];	# 13
	 [3 17 31];		# 14
	 [4 18 32 46 58 70];	# 15
	 [19 33];		# 16
	 [5 40 47];		# 17
	 [6 41 48 51 59 71];	# 18
	 [20 34];		# 19
	 [7 21 35];		# 20
	 [64 66 72];		# 21
	 [8 22 36];		# 22
	 [23 37];		# 23
	 [9 42 49];		# 24
	 [10 43 50 65 67 73];	# 25
	 [24 38];		# 26
	 [11 25 39];		# 27
	 [52 60 74];		# 28
	 [12 26 53 61 75];	# 29
	 [13 27 54 62 76];	# 30
	 [14 28 55 63 77];	# 31 <---Vertical lines---end
	 [58 59];		# 32 <---SW-NE lines---begin
	 [46 51];		# 33
	 [59 66];		# 34
	 [51 64];		# 35
	 [32 47];		# 36
	 [33 40];		# 37
	 [31 46];		# 38
	 [6 20];		# 39
	 [36 49];		# 40
	 [37 42];		# 41
	 [10 24];		# 42 <---SW-NE lines---end
	 [5 19];		# 43 <---SE-NW lines---begin
	 [34 41];		# 44
	 [35 48];		# 45
	 [9 23];		# 46
	 [38 43];		# 47
	 [39 50];		# 48
	 [52 65];		# 49
	 [60 67]};		# 50 <---SW_NE lines---end
	 
#
global Edges;
Edges = [1 1 2;		     # 1 <---Line 1---begins *Horizontal begins*
	 1 2 3;		     # 2
	 1 3 4;		     # 3
	 1 4 5;		     # 4
	 1 5 6;		     # 5
	 1 6 7;		     # 6
	 1 7 8;		     # 7
	 1 8 9;		     # 8
	 1 9 10;	     # 9
	 1 10 11;	     # 10
	 1 11 12;	     # 11
	 1 12 13;	     # 12
	 1 13 14;	     # 13 <---Line 1---ends
	 2 15 16;	     # 14 <---Line 2---begins
	 2 16 17;	     # 15
	 2 17 18;	     # 16
	 2 18 19;	     # 17
	 2 20 21;	     # 18
	 2 21 22;	     # 19
	 2 22 23;	     # 20
	 2 24 25;	     # 21
	 2 25 26;	     # 22
	 2 26 27;	     # 23
	 2 27 28;	     # 24 <---Line 2---ends
	 3 29 30;	     # 25 <---Line 3---begins
	 3 30 31;	     # 26
	 3 32 33;	     # 27
	 3 34 35;	     # 28
	 3 36 37;	     # 29
	 3 38 39;	     # 30 <---Line 3---ends
	 4 40 41;	     # 31 <---Line 4---ends
	 4 42 43;	     # 32 <---Line 4---ends
	 5 44 45;	     # 33 <---Line 5---ends
	 5 45 46;	     # 34
	 5 47 48;	     # 35
	 5 49 50;	     # 36 <---Line 5---ends
	 6 52 53;	     # 37 <---Line 6---begins
	 6 53 54;	     # 38
	 6 54 55;	     # 39 <---Line 6---ends
	 7 56 57;	     # 40 <---Line 7---begins
	 7 57 58;	     # 41 <---Line 7---ends
	 8 60 61;	     # 42 <---Line 8---begins
	 8 61 62;	     # 43
	 8 62 63;	     # 44 <---Line 8---ends
	 9 64 65;	     # 45 <---Line 9
	 10 66 67;	     # 46 <---Line 10
	 11 68 69;	     # 47 <---Line 11---begins
	 11 69 70;	     # 48
	 11 70 71;	     # 49
	 11 71 72;	     # 50
	 11 72 73;	     # 51
	 11 73 74;	     # 52
	 11 74 75;	     # 53
	 11 75 76;	     # 54
	 11 76 77;	     # 55 <---Line 11---ends *Horizontal ends*
	 12 1 15;	     # 56 <---Line 12---begins *Vertical begins*
	 12 15 29;	     # 57
	 12 29 44;	     # 58
	 12 44 56;	     # 59
	 12 56 68;	     # 60 <---Line 12---ends
	 13 2 16;	     # 61 <---Line 13---begins
	 13 16 30;	     # 62
	 13 30 45;	     # 63
	 13 45 57;	     # 64
	 13 57 69;	     # 65 <---Line 13---ends
	 14 3 17;	     # 66 <---Line 14---begins
	 14 17 31;	     # 67 <---Line 14---ends
	 15 4 18;	     # 68 <---Line 15---begins
	 15 18 32;	     # 69
	 15 46 58;	     # 70
	 15 58 70;	     # 71 <---Line 15---ends
	 16 19 33;	     # 72 <---Line 16
	 17 40 47;	     # 73 <---Line 17
	 18 41 48;	     # 74 <---Line 18---begins
	 18 51 59;	     # 75
	 18 59 71;	     # 76 <---Line 18---ends
	 19 20 34;	     # 77 <---Line 19
	 20 7 21;	     # 78 <---Line 20---begins
	 20 21 35;	     # 79 <---Line 20---ends
	 21 64 66;	     # 80 <---Line 21---begins
	 21 66 72;	     # 81 <---Line 21---ends
	 22 8 22;	     # 82 <---Line 22---begins
	 22 22 36;	     # 83 <---Line 22--ends
	 23 23 37;	     # 84 <---Line 23
	 24 42 49;	     # 85 <---Line 24
	 25 43 50;	     # 86 <---Line 25---begins
	 25 65 67;	     # 87
	 25 67 73;	     # 88 <---Line 25---ends
	 26 24 38;	     # 89 <---Line 26
	 27 11 25;	     # 90 <---Line 27---begins
	 27 25 39;	     # 91 <---Line 27---ends
	 28 52 60;	     # 92 <---Line 28---begins
	 28 60 74;	     # 93 <---Line 28---ends
	 29 12 26;	     # 94 <---Line 29---begins
	 29 26 53;	     # 95
	 29 53 61;	     # 96
	 29 61 75;	     # 97 <---Line 29---ends
	 30 13 27;	     # 98 <---Line 30---begins
	 30 27 54;	     # 99
	 30 54 62;	     # 100
	 30 62 76;	     # 101 <---Line 30---ends
	 31 14 28;	     # 102 <---Line 31---begins
	 31 28 55;	     # 103
	 31 55 63;	     # 104
	 31 63 77;	     # 105 <---Line 31---ends *Vertical ends*
	 32 58 59;	     # 106 *SW-NE begins*
	 34 59 66 ;	     # 107
	 33 46 51;	     # 108
	 35 51 64;	     # 109
	 38 31 46;	     # 110
	 36 32 47;	     # 111
	 37 33 40;	     # 112
	 39 6 20;	     # 113
	 40 36 49;	     # 114
	 41 37 42;	     # 115
	 42 10 24;	     # 116 *SW-NE ends*
	 43 5 19;	     # 117 *SE-NW begins*
	 44 34 41;	     # 118
	 45 35 48;	     # 119
	 46 9 23;	     # 120
	 47 38 43;	     # 121
	 48 39 50;	     # 122
	 49 52 65;	     # 123
	 50 60 67];	     # 124 *SE-NW ends*
#
BEdges = [1 2 3 4 5 6 7 8 9 10 11 12 13 \
	  16 19 22 \
	  31 32 \
	  35 36 \
	  37 \
	  45 \
	  47 48 49 50 51 52 53 54 55 \
	  56 57 58 59 60 \
	  67 \
	  69 \
	  72 \
	  77 \
	  79 \
	  83 \
	  84 \
	  89 \
	  91 \
	  95 \
	  102 103 104 105 \
	  108 109 \
	  110 111 112 113 \
	  114 115 116 \
	  117 118 119 \
	  120 121 122 123];
#
## Almost anti-clockwise ordering
global IEdges;
IEdges = [61 66 68 17 27 73 74 28 18 78 82 20 29 85 86 30 21 90 94 98 \
	  24 99 23 38 100 39 \
	  44 101 43 97 42 96 92 93 124 87 46 88 81 107 80 75 106 76 71 \
	  65 40 41 70 64 33 34 63 25 26 62 14 15];
#
# Anti-clockwise edges; almost anti-clockwise ordering
Quads = {[1 61 -14 -56];	# 1
	 [2 66 -15 -61];	# 2
	 [3 68 -16 -66];	# 3
	 [4 117 -17 -68];	# 4
	 [17 72 -27 -69];	# 5
	 [27 112 73 -111];	# 6
	 [31 74 -35 -73];	# 7
	 [28 119 -74 -118];	# 8
	 [18 79 -28 -77];	# 9
	 [6 78 -18 -113];	# 10
	 [7 82 -19 -78];	# 11
	 [8 120 -20 -82];	# 12
	 [20 84 -29 -83];	# 13
	 [29 115 85 -114];	# 14
	 [32 86 -36 -85];	# 15
	 [30 122 -86 -121];	# 16
	 [21 91 -30 -89];	# 17
	 [10 90 -21 -116];	# 18
	 [11 94 -22 -90];	# 19
	 [12 98 -23 -94];	# 20
	 [13 102 -24 -98];	# 21
	 [24 103 -39 -99];	# 22
	 [23 99 -38 -95];	# 23
	 [38 100 -43 -96];	# 24
	 [39 104 -44 -100];	# 25
	 [44 105 -55 -101];	# 26
	 [43 101 -54 -97];	# 27
	 [42 97 -53 -93];	# 28
	 [37 96 -42 -92];	# 29
	 [-123 92 124 -87];	# 30
	 [-124 93 -52 -88];	# 31
	 [46 88 -51 -81];	# 32
	 [45 87 -46 -80];	# 33
	 [109 80 -107 -75];	# 34
	 [107 81 -50 -76];	# 35
	 [106 76 -49 -71];	# 36
	 [108 75 -106 -70];	# 37
	 [34 70 -41 -64];	# 38
	 [41 71 -48 -65];	# 39
	 [40 65 -47 -60];	# 40
	 [33 64 -40 -59];	# 41
	 [25 63 -33 -58];	# 42
	 [26 110 -34 -63];	# 43
	 [14 62 -25 -57];	# 44
	 [15 67 -26 -62]};	# 45
#
## Create grids on interior edges
ne = 13;
igrid = cell (58, 1);
for i = 1 : 58
  ei = IEdges(i);
  vt1 = Edges(ei, 2);
  vt2 = Edges(ei, 3);
  igrid{i} = toEdge (Pts(vt1,:), Pts(vt2,:), cheb_zeros(ne));
endfor
#
nse = ne * ones(124,1);		# points on edges
##
ss = 10.0 * ones(45,1);		# Sobolev for each Quad
nx = ne;
ny = ne;
ns = ones (45,1) * [nx ny];	# No. of points for each Quad
#
M1 = 2.5;			# MSN amp factor
##
Geom.Pts = Pts;
Geom.Lines = Lines;
Geom.Edges = Edges;
Geom.BEdges = BEdges;
Geom.IEdges = IEdges;
Geom.Quads = Quads;

##################################
############ Div-curl  ###########
##################################

p = 2;
q = 2;
nrhs = 1;

function A1 = coeff1x (j, x)
  A1 = eye (2, class (x));
endfunction

function A2 = coeff1y (j, x)
  A2 = [0 1; -1 0];
  A2 = cast (A2, class (x));
endfunction

function B = coeff0 (j, x)
  B = zeros (2, 2, class (x));
endfunction

function u = soln (xy)
  x = xy(1);
  y = xy(2);
  u = [1/(1 + x^2 + y^2);
       x^2 - 2*y^2 + x*y - x + 1];
  # u = [1+x-y+x*y+x^3; \
  #      x+y-x^2+y^2-5*y*x^2];
  u = cast (u, class (xy));
endfunction

# [u1_x u1_y; u2_x u2_y]
function up = solnp (xy)
  x = xy(1);
  y = xy(2); 
  up = [-2*x/(1+x^2+y^2)^2, -2*y/(1+x^2+y^2)^2;
  	2*x+y-1, -4*y+x];
  # up = [1+y+3*x^2, -1+x; \
  # 	1-2*x-10*y*x, 1+2*y-5*x^2];
  up = cast (up, class (xy));
endfunction

function du = curl (gu)
  du = gu(2,1) - gu(1,2);
endfunction

function du = div (gu)
  du = gu(1,1) + gu(2,2);
endfunction

function f = rhs(j, x)
  gu = solnp (x);
  f = [(div (gu));
       (curl (gu))];
  f = cast (f, class (x));
endfunction

function tngnt = tangent (j)
  global Pts;
  global Edges;
  vt1 = Pts(Edges(j,2),:);
  vt2 = Pts(Edges(j,3),:);
  tngnt = vt2 - vt1;
endfunction

## Rotate by 90
function nrm = rot90 (j)
  global Pts;
  global Edges;
  vt1 = Pts(Edges(j,2),:);
  vt2 = Pts(Edges(j,3),:);
  t = vt2 - vt1;
  nrm = [t(2), -t(1)];
endfunction

## Rotate by -90
function nrm = rot_90 (j)
  global Pts;
  global Edges;
  vt1 = Pts(Edges(j,2),:);
  vt2 = Pts(Edges(j,3),:);
  t = vt2 - vt1;
  nrm = [-t(2), t(1)];
endfunction

function C = boundcoeff (j, xy)
  global IEdges;
  if any (j == [1 2 3 4 6 7 8 10 11 12 13])
    C = [1 0];			# tangential
  elseif any (j == [102 103 104 105])
    C = [0 1];			# tangential
  elseif any (j == [47 48 49 50 51 52 53 54 55])
    C = [-1 0];			# tangential
  elseif any (j == [56 57 58 59 60])
    C = [0 -1];			# tangential
  elseif any (j == [5 9])
    error ("My bad");
  elseif any (j == [117 72 112 31])
    C = tangent (j);		# tangential
  elseif any (j == [118 77 113])
    C = -tangent (j);		# tangential
  elseif any (j == [120 84 115 32])
    C = tangent (j);		# tangential
  elseif any (j == [121 89 116])
    C = -tangent (j);		# tangential
  elseif any (j == [16 35 19 36 22])
    C = [0 -1];			# normal
  elseif any (j == [45 37])
    C = [0 1];			# normal
  elseif any (j == [69 83 95])
    C = [1 0];			# normal
  elseif any (j == [67 79 91])
    C = [-1 0];			# normal
  elseif any (j == [111 114 123 ])
    C = rot90 (j);		# normal
  elseif any (j == [119 122 109 108 110])
    C = rot_90 (j);		# normal
  elseif any (j == IEdges)
    error ("Interface");
  else
    error("Unknown edge index")
  endif
  C = cast(C, class(xy));
endfunction

function g = boundrhs(j, xy)
  u = soln (xy);
  C = boundcoeff (j, xy);
  g = C * u;
endfunction

#############################################
#############################################
#############################################

[zzs, us1] = msnPDE (Geom, igrid, q, p, nrhs, \
		    @coeff1x, @coeff1y, @coeff0, @rhs, \
		    @boundcoeff, @boundrhs, ss, ns, nse, M1);
#

m = rows (zzs);
us1 = reshape (us1, p, m);

#

us2 = zeros (p, m);
for i = 1 : m
  us2(:,i) = soln (zzs(i,:));
endfor
us2;

#

err = norm (us1-us2, Inf) / norm (us2, Inf)

#
clear Pts;
clear Edges;
clear IEdges;

# Local Variables: #
# mode: octave     #
# End:             #
