# Function that is very rough on the boundary but super-smooth on the inside

N = 60;
M = 20;

tx = ty = linspace(-1, 1, N);
tz = meshgrid(tx, ty);
for i=1:N
  for j=1:N
    for n=0:M
      tz(i,j) = tz(i,j) + tx(i)^(n^4) * cheb(ty(j),n^4) / (1+n^4);
    endfor
  endfor
endfor

mesh(tx, ty, tz);


# Local Variables: #
# mode: octave     #
# End:             #
