% Usage z = cheb2D_zeros (n)
%
% cheb2D (z(i,:),n) == 0
%

function z = cheb2D_zeros (n)
  n1 = n(1);
  n2 = n(2);
  z = [(kron (cheb_zeros (n1), ones (n2, 1))), \
       (kron (ones (n1, 1), cheb_zeros (n2)))];
endfunction


% Local Variables: %
% mode: octave     %
% End:             %
