% Usage: from_interval(a,b,xs)
%
% Assumes a <= xs(i) <= b
% Returns ys(i) = (xs(i)-a) * 2/(b-a) - 1
% Affine linear map from [a,b] to [-1,1]

function ys = from_interval (a, b, xs)
  ys = (xs-a)*2/(b-a)-1;
endfunction

% Local Variables: %
% mode: octave     %
% End:             %
