## 

function [Do, U] = iterDS (Di, Q, n)
  M = rows (Q);
  Do = Di;
  U = Q;
  for k = 1 : n
    for i = 1 : M
      qi = norm (U(i,:));
      Do(i) = Do(i) * qi;
      U(i,:) = U(i,:) / qi;
    endfor
    cond (U)
    [U,_,_] = qr(U,0);
  endfor
endfunction


% Local Variables: %
% mode: octave     %
% End:             %
