# Usage fs = samp_cheb2D (XY, xs, ord, as)
#
# XY --- vertices in anti-clockwise order (4x2)
# xs --- points where the Cheb. expansion should be evaluated
# ord -- order of each Chebyshev polynomial
# as --- Cheb. coefficients
#
# $Id$
#

function fs = samp_cheb2D (XY, xs, ord, as)
  fs = cheb2D (fromQuad (XY, xs), ord) * as;
endfunction

# Local Variables: #
# mode: octave     #
# End:             #
