% Usage: to_interval(a,b,xs)
%
% Assumes -1 <= xs(i) <= 1
% Returns ys(i) = a + (xs(i)+1) * (b-a)/2
% Affine linear map from [-1,1] to [a,b]

function ys = to_interval (a, b, xs)
  ys = a+(xs+1)*(b-a)/2;
endfunction

% Local Variables: %
% mode: octave     %
% End:             %
